public inbox for git-commits@fedoraproject.org
help / color / mirror / Atom feed
From: Milos Malik <mmalik@redhat.com>
To: git-commits@fedoraproject.org
Subject: [tests/selinux] pr775-checkpolicy-revdeps: add a new test which covers systemd-notify
Date: Fri, 11 Sep 2026 13:19:57 GMT	[thread overview]
Message-ID: <178913279748.1.14012881738948020351.tests-selinux-00be497d473b@fedoraproject.org> (raw)

            A new commit has been pushed.

            Repo   : tests/selinux
            Branch : pr775-checkpolicy-revdeps
            Commit : 00be497d473bfea3d86eaa5e987c6f98f5dafeb3
            Author : Milos Malik <mmalik@redhat.com>
            Date   : 2022-05-09T07:58:50+00:00
            Stats  : +215/-0 in 6 file(s)
            URL    : https://src.fedoraproject.org/tests/selinux/c/00be497d473bfea3d86eaa5e987c6f98f5dafeb3?branch=pr775-checkpolicy-revdeps

            Log:
            add a new test which covers systemd-notify

The systemd-notify program is confined by SELinux, but there was no
SELinux related test coverage sofar. This automated TC will contain
some basic scenarios and should improve this situation.

As described in BZ#1903106, current SELinux policy is one of the
factors which prevent systemd from proper notify handling. Missing
rules in SELinux policy lead to the following error message:

  Failed to invoke barrier: Connection timed out

The TC covers BZ#1903305, looks for appropriate SELinux policy rules
and it also reproduces the scenario.

What if an unconfined service tries to use the systemd-notify?
Will it work successfully without SELinux denials?

---
diff --git a/selinux-policy/systemd-notify-and-similar/Makefile b/selinux-policy/systemd-notify-and-similar/Makefile
new file mode 100644
index 0000000..d355f29
--- /dev/null
+++ b/selinux-policy/systemd-notify-and-similar/Makefile
@@ -0,0 +1,68 @@
+# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+#
+#   Makefile of /CoreOS/selinux-policy/Regression/systemd-notify-and-similar
+#   Description: SELinux interferes with systemd-notify and related programs
+#   Author: Milos Malik <mmalik@redhat.com>
+#
+# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+#
+#   Copyright (c) 2020 Red Hat, Inc. All rights reserved.
+#
+#   This copyrighted material is made available to anyone wishing
+#   to use, modify, copy, or redistribute it subject to the terms
+#   and conditions of the GNU General Public License version 2.
+#
+#   This program is distributed in the hope that it will be
+#   useful, but WITHOUT ANY WARRANTY; without even the implied
+#   warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
+#   PURPOSE. See the GNU General Public License for more details.
+#
+#   You should have received a copy of the GNU General Public
+#   License along with this program; if not, write to the Free
+#   Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
+#   Boston, MA 02110-1301, USA.
+#
+# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+
+export TEST=/CoreOS/selinux-policy/Regression/systemd-notify-and-similar
+export TESTVERSION=1.0
+
+BUILT_FILES=
+
+FILES=$(METADATA) runtest.sh Makefile PURPOSE local-notifier.service notifier.sh
+
+.PHONY: all install download clean
+
+run: $(FILES) build
+	./runtest.sh
+
+build: $(BUILT_FILES)
+	chmod a+x runtest.sh notifier.sh
+	chcon -t bin_t runtest.sh notifier.sh
+
+clean:
+	rm -f *~ $(BUILT_FILES)
+
+include /usr/share/rhts/lib/rhts-make.include
+
+$(METADATA): Makefile
+	@echo "Owner:           Milos Malik <mmalik@redhat.com>" > $(METADATA)
+	@echo "Name:            $(TEST)" >> $(METADATA)
+	@echo "TestVersion:     $(TESTVERSION)" >> $(METADATA)
+	@echo "Path:            $(TEST_DIR)" >> $(METADATA)
+	@echo "Description:     SELinux interferes with systemd-notify and related programs" >> $(METADATA)
+	@echo "Type:            Regression" >> $(METADATA)
+	@echo "TestTime:        10m" >> $(METADATA)
+	@echo "RunFor:          selinux-policy" >> $(METADATA)
+	@echo "Requires:        audit libselinux libselinux-utils policycoreutils selinux-policy selinux-policy-targeted setools-console systemd /usr/sbin/service" >> $(METADATA)
+	@echo "RhtsRequires:    library(selinux-policy/common)" >> $(METADATA)
+	@echo "Environment:     AVC_ERROR=+no_avc_check" >> $(METADATA)
+	@echo "Priority:        Normal" >> $(METADATA)
+	@echo "License:         GPLv2" >> $(METADATA)
+	@echo "Confidential:    no" >> $(METADATA)
+	@echo "Destructive:     no" >> $(METADATA)
+	@echo "Releases:        -RHEL4 -RHEL5 -RHEL6" >> $(METADATA)
+	@echo "Bug:             1903305" >> $(METADATA) # Fedora 33
+
+	rhts-lint $(METADATA)
+

diff --git a/selinux-policy/systemd-notify-and-similar/PURPOSE b/selinux-policy/systemd-notify-and-similar/PURPOSE
new file mode 100644
index 0000000..b236d83
--- /dev/null
+++ b/selinux-policy/systemd-notify-and-similar/PURPOSE
@@ -0,0 +1,5 @@
+PURPOSE of /CoreOS/selinux-policy/Regression/systemd-notify-and-similar
+Author: Milos Malik <mmalik@redhat.com>
+
+SELinux interferes with systemd-notify and related programs.
+

diff --git a/selinux-policy/systemd-notify-and-similar/local-notifier.service b/selinux-policy/systemd-notify-and-similar/local-notifier.service
new file mode 100644
index 0000000..db5a1b4
--- /dev/null
+++ b/selinux-policy/systemd-notify-and-similar/local-notifier.service
@@ -0,0 +1,7 @@
+[Unit]
+Description=Local notifier service
+
+[Service]
+Type=oneshot
+ExecStart=/usr/local/bin/notifier.sh
+

diff --git a/selinux-policy/systemd-notify-and-similar/main.fmf b/selinux-policy/systemd-notify-and-similar/main.fmf
new file mode 100644
index 0000000..7474823
--- /dev/null
+++ b/selinux-policy/systemd-notify-and-similar/main.fmf
@@ -0,0 +1,41 @@
+summary: SELinux interferes with systemd-notify and related programs
+description: |+
+    SELinux interferes with systemd-notify and related programs
+
+contact: Milos Malik <mmalik@redhat.com>
+component:
+  - selinux-policy
+test: ./runtest.sh
+framework: beakerlib
+require:
+  - library(selinux-policy/common)
+recommend:
+  - audit
+  - libselinux
+  - libselinux-utils
+  - policycoreutils
+  - selinux-policy
+  - selinux-policy-targeted
+  - setools-console
+  - systemd
+  - /usr/sbin/service
+duration: 10m
+enabled: true
+tag:
+  - NoRHEL4
+  - NoRHEL5
+  - NoRHEL6
+  - NoRHEL7
+  - Tier2
+  - Tier2se
+  - targeted
+tier: '2'
+link:
+  - verifies: https://bugzilla.redhat.com/show_bug.cgi?id=1903305
+adjust:
+  - enabled: false
+    when: distro == rhel-4, rhel-5, rhel-6, rhel-7
+    continue: false
+extra-summary: /CoreOS/selinux-policy/Regression/systemd-notify-and-similar
+extra-task: /CoreOS/selinux-policy/Regression/systemd-notify-and-similar
+extra-nitrate: TC#0613581

diff --git a/selinux-policy/systemd-notify-and-similar/notifier.sh b/selinux-policy/systemd-notify-and-similar/notifier.sh
new file mode 100755
index 0000000..e8d7554
--- /dev/null
+++ b/selinux-policy/systemd-notify-and-similar/notifier.sh
@@ -0,0 +1,5 @@
+#!/bin/bash
+id -Z
+NOTIFY_SOCKET=/run/systemd/notify systemd-notify --ready
+NOTIFY_SOCKET=/run/systemd/notify systemd-notify --ready
+

diff --git a/selinux-policy/systemd-notify-and-similar/runtest.sh b/selinux-policy/systemd-notify-and-similar/runtest.sh
new file mode 100755
index 0000000..24d276f
--- /dev/null
+++ b/selinux-policy/systemd-notify-and-similar/runtest.sh
@@ -0,0 +1,89 @@
+#!/bin/bash
+# vim: dict=/usr/share/beakerlib/dictionary.vim cpt=.,w,b,u,t,i,k
+# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+#
+#   runtest.sh of /CoreOS/selinux-policy/Regression/systemd-notify-and-similar
+#   Description: SELinux interferes with systemd-notify and related programs
+#   Author: Milos Malik <mmalik@redhat.com>
+#
+# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+#
+#   Copyright (c) 2020 Red Hat, Inc. All rights reserved.
+#
+#   This copyrighted material is made available to anyone wishing
+#   to use, modify, copy, or redistribute it subject to the terms
+#   and conditions of the GNU General Public License version 2.
+#
+#   This program is distributed in the hope that it will be
+#   useful, but WITHOUT ANY WARRANTY; without even the implied
+#   warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
+#   PURPOSE. See the GNU General Public License for more details.
+#
+#   You should have received a copy of the GNU General Public
+#   License along with this program; if not, write to the Free
+#   Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
+#   Boston, MA 02110-1301, USA.
+#
+# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+
+# Include Beaker environment
+. /usr/share/beakerlib/beakerlib.sh || exit 1
+
+PACKAGE="selinux-policy"
+SERVICE_PACKAGE="systemd"
+
+rlJournalStart
+    rlLog "If this test fails, please contact mmalik on IRC #selinux"
+    rlLog "This test should fail if tested bugs are NOT fixed yet"
+    rlPhaseStartSetup
+        rlRun "rlImport 'selinux-policy/common'"
+        rlSESatisfyRequires
+        rlAssertRpm ${PACKAGE}
+        rlAssertRpm ${PACKAGE}-targeted
+        rlAssertRpm ${SERVICE_PACKAGE}
+
+        rlSESetEnforce
+        rlSEStatus
+        rlSESetTimestamp
+        sleep 2
+    rlPhaseEnd
+
+    rlPhaseStartTest "bz#1903305"
+        rlSEMatchPathCon "/usr/bin/systemd-notify" "systemd_notify_exec_t"
+        rlSESearchRule "allow init_t unconfined_t : fifo_file { write } [ ]"
+        rlSESearchRule "allow systemd_notify_t user_devpts_t : chr_file { read write append } [ ]"
+        rlSESearchRule "allow systemd_notify_t systemd_notify_t : capability { net_admin } [ ]"
+        rlSESearchRule "allow systemd_notify_t kernel_t : unix_dgram_socket { sendto } [ ]"
+    rlPhaseEnd
+
+    rlPhaseStartTest "real scenario -- bz#1903305"
+        rlRun "NOTIFY_SOCKET=/run/systemd/notify systemd-notify --ready"
+        sleep 1
+        rlRun "NOTIFY_SOCKET=/run/systemd/notify systemd-notify --ready"
+    rlPhaseEnd
+
+    rlPhaseStartTest "real scenario -- runcon under root"
+        rlRun "NOTIFY_SOCKET=/run/systemd/notify runcon system_u:system_r:initrc_t:s0 bash -c 'systemd-notify --ready'"
+        sleep 1
+        rlRun "NOTIFY_SOCKET=/run/systemd/notify runcon system_u:system_r:initrc_t:s0 bash -c 'systemd-notify --ready'"
+    rlPhaseEnd
+
+    rlPhaseStartTest "real scenario -- unconfined service uses systemd-notify"
+        rlRun "cp -f notifier.sh /usr/local/bin/"
+        rlRun "cp -f local-notifier.service /usr/lib/systemd/system/"
+        rlRun "restorecon -v /usr/local/bin/notifier.sh /usr/lib/systemd/system/local-notifier.service"
+        rlRun "systemctl daemon-reload"
+        rlRun "service local-notifier start"
+        sleep 2
+        rlRun "service local-notifier status"
+        rlRun "rm -f /usr/lib/systemd/system/local-notifier.service /usr/local/bin/notifier.sh"
+        rlRun "systemctl daemon-reload"
+    rlPhaseEnd
+
+    rlPhaseStartCleanup
+        sleep 2
+        rlSECheckAVC
+    rlPhaseEnd
+rlJournalPrintText
+rlJournalEnd
+

                 reply	other threads:[~2026-09-11 13:19 UTC|newest]

Thread overview: [no followups] expand[flat|nested]  mbox.gz  Atom feed

Reply instructions:

You may reply publicly to this message via plain-text email
using any one of the following methods:

* Save the following mbox file, import it into your mail client,
  and reply-to-all from there: mbox

  Avoid top-posting and favor interleaved quoting:
  https://en.wikipedia.org/wiki/Posting_style#Interleaved_style

* Reply using the --to, --cc, and --in-reply-to
  switches of git-send-email(1):

  git send-email \
    --in-reply-to=178913279748.1.14012881738948020351.tests-selinux-00be497d473b@fedoraproject.org \
    --to=mmalik@redhat.com \
    --cc=git-commits@fedoraproject.org \
    /path/to/YOUR_REPLY

  https://kernel.org/pub/software/scm/git/docs/git-send-email.html

* If your mail client supports setting the In-Reply-To header
  via mailto: links, try the mailto: link
Be sure your reply has a Subject: header at the top and a blank line before the message body.
This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox